module.exports = {
  env: {
    browser: true,
    es2021: true,
    mocha: true,
  },
  extends: ['airbnb-base'],
  overrides: [
    {
      files: ['*.test.js'],
      rules: {
        'no-unused-expressions': 'off',
      },
    },
  ],
  parserOptions: {
    ecmaVersion: 'latest',
    sourceType: 'module',
  },
  plugins: [
    'import',
    'html',
  ],
  rules: {
    'import/extensions': ['error', 'always'],
    'import/prefer-default-export': ['off'],
    'import/no-unresolved': ['error', { ignore: ['^http'] }],
    'import/no-absolute-path': ['off'],
    'no-unused-vars': ['error', { argsIgnorePattern: '^_' }],
    'max-classes-per-file': ['off'],
    'no-param-reassign': ['off'],
    'no-plusplus': ['off'],
    'no-restricted-syntax': ['off'],
    'max-len': ['warn', 120],
    'no-console': ['off'],
    'no-return-assign': ['off'],
    'no-multi-assign': ['off'],
    'no-constant-condition': ['off'],
    'no-await-in-loop': ['off'],
    'no-underscore-dangle': ['off'],
  },
  globals: {
    _: 'readonly',
    chai: 'readonly',
    sinon: 'readonly',
    sinonChai: 'readonly',
    should: 'readonly',
    mocha: 'readonly',
  },
};
